#IF 0  ' 

    create a random pad of user specified length
    Build with PBCC50

#ENDIF ' 

    %usemacros = 1

    #include "\pbwin90\include\win32api.inc"    ' << change this to your own path

    GLOBAL rseed as LONG

    MACRO FUNCTION GetSeed
      MACROTEMP var
      LOCAL var as DWORD
      GetTickCount
      ! bswap eax
      ! not eax
      ! mov var, eax
    END MACRO = var

' 

FUNCTION PBmain as LONG

    LOCAL userlength as LONG
    LOCAL nflag      as DWORD

    cmd$ = command$
    nflag = 0

    userlength = val(cmd$)

    If userlength = 0 Then
      userlength = 1024 * 1024      ' set to 1 meg if no command line size specified
      nflag = 1
    End If

    rseed = GetSeed

    pad$ = create_random_pad(userlength)

    Open "pad.txt" for output as #1
      Print #1, pad$;
    Close #1

    If nflag = 0 Then
      StdOut "User specified " + ltrim$(str$(len(pad$))) + " bytes written"
    Else
      StdOut "No command line size specified, default 1 meg written"
    End If

    FUNCTION = 0

End FUNCTION

' 

FUNCTION create_random_pad(ByVal ln as DWORD) as STRING

  ' --------------------------------------------------------------------------
  ' rseed is a GLOBAL that must contain a value BEFORE this function is called
  ' --------------------------------------------------------------------------
    #REGISTER NONE

    LOCAL pPad    as DWORD

    pad$ = space$(ln)                   ' allocate "ln" bytes in a basic string
    pPad = StrPtr(pad$)                 ' get the string address

    ! mov esi, pPad                     ' put the string address in ESI
    ! mov ecx, rseed
    ! mov ebx, 255

    ! mov edi, ln                       ' store ln in EAX before altering EBP

  #align 4
  lpst:
    ! mov eax, ecx
    ! test eax, &H80000000
    ! jz  ovr
    ! add eax, &H7FFFFFFF
  ovr:   
    ! xor edx, edx
    ! mov ecx, 127773
    ! div ecx
    ! mov ecx, eax
    ! mov eax, 16807
    ! mul edx
    ! mov edx, ecx
    ! mov ecx, eax
    ! mov eax, 2836
    ! mul edx
    ! sub ecx, eax
    ! xor edx, edx
    ! mov eax, ecx
    ! div ebx
    ! mov eax, edx
    ! mov BYTE PTR [esi], al            ' write 1st byte to basic string
    ! add esi, 1                        ' increment ESI
    ! sub edi, 1                        ' decrement the length counter
    ! jnz lpst

    FUNCTION = pad$                     ' return the random pad as a string

End FUNCTION

' 
